/* -*-C-*-
*******************************************************************************
*
* File:         xtangofills.h
* RCS:          $Header: /disk3/npm/src/winterp/src-server/xtango/RCS/xtangofills.h,v 2.5 1994/06/09 01:32:06 npm Exp $
* Description:  XTANGO ANIMATION PACKAGE (fills.h)
* Author:       John T. Stasko, Doug Hayes, Niels Mayer
* Created:      1990
* Modified:     Sun Jun  5 05:23:48 1994 (Niels Mayer) npm@indeed
* Language:     C
* Package:      N/A
* Status:	X11r6 contrib release
*
* Xtango 1.52 Copyright 1990-1994 Georgia Institute of Technology
* 			     (by John T. Stasko and Doug Hayes).
* WINTERP 2.0 Copyright (C) 1994, Enterprise Integration Technologies Corp. and Niels Mayer.
* WINTERP 1.15-1.99, Copyright (c) 1993, Niels P. Mayer.
* WINTERP 1.0-1.14, Copyright (c) 1989-1992 Hewlett-Packard Co. and Niels Mayer.
* 
* This version of Xtango 1.52 (varargs version) represents a subset of
* the Xtango distribution that has been modified specifically for use with
* WINTERP. Non-WINTERP uses of Xtango should use the complete, standard
* version of Xtango, which is available under separate copyright via
* anonymous ftp from par.cc.gatech.edu:pub/xtangovarargs.tar.Z and
* par.cc.gatech.edu:pub/xtango.tar.Z.
* 
* Permission to use, copy, modify, distribute, and sell this software and its
* documentation for any purpose is hereby granted without fee, provided that
* the above copyright notice appear in all copies and that both that
* copyright notice and this permission notice appear in supporting
* documentation, and that the name of Georgia Institute of Technology, 
* John T. Stasko, Doug Hayes, Enterprise Integration Technologies, 
* Hewlett-Packard Company, or Niels Mayer not be used in advertising or
* publicity pertaining to distribution of the software without specific,
* written prior permission. Georgia Institute of Technology, John T. Stasko,
* Doug Hayes, Enterprise Integration Technologies, Hewlett-Packard Company,
* and Niels Mayer makes no representations about the suitability of this 
* software for any purpose.  It is provided "as is" without express or
* implied warranty.
* 
* GEORGIA INSTITUTE OF TECHNOLOGY, JOHN T. STASKO, DOUG HAYES, ENTERPRISE
* INTEGRATION TECHNOLOGIES, HEWLETT-PACKARD COMPANY AND NIELS MAYER
* DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL GEORGIA
* INSTITUTE OF TECHNOLOGY, JOHN T. STASKO, DOUG HAYES, ENTERPRISE INTEGRATION
* TECHNOLOGIES, HEWLETT-PACKARD COMPANY OR NIELS MAYER BE LIABLE
* FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
* RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
* CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
* CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*
*******************************************************************************
*/

/**************************************************************/
/*****************	LOCAL variables      ******************/
/**************************************************************/

static char _fillStyles[][8] = {	/* Local to xtangogc.c */
   {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
   {0x01, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00},
   {0x01, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00},
   {0x11, 0x00, 0x04, 0x00, 0x11, 0x00, 0x00, 0x00},
   {0x11, 0x00, 0x04, 0x00, 0x11, 0x00, 0x40, 0x00},
   {0x11, 0x00, 0x44, 0x00, 0x11, 0x00, 0x44, 0x00},
   {0x11, 0x00, 0x45, 0x00, 0x11, 0x00, 0x54, 0x00},
   {0x11, 0x00, 0x45, 0x00, 0x11, 0x00, 0x55, 0x00},
   {0x15, 0x00, 0x55, 0x00, 0x11, 0x00, 0x55, 0x00},
   {0x15, 0x00, 0x55, 0x00, 0x51, 0x00, 0x55, 0x00},
   {0x55, 0x00, 0x55, 0x00, 0x55, 0x00, 0x55, 0x00},
   {0x55, 0x02, 0x55, 0x00, 0x55, 0x20, 0x55, 0x00},
   {0x55, 0x02, 0x55, 0x00, 0x55, 0x22, 0x55, 0x00},
   {0x55, 0x22, 0x55, 0x08, 0x55, 0x22, 0x55, 0x00},
   {0x55, 0x22, 0x55, 0x08, 0x55, 0x22, 0x55, 0x80},
   {0x55, 0x22, 0x55, 0x88, 0x55, 0x22, 0x55, 0x88},
   {0x55, 0x22, 0x55, 0x8a, 0x55, 0x22, 0x55, 0xa8},
   {0x55, 0x22, 0x55, 0x8a, 0x55, 0x22, 0x55, 0xaa},
   {0x55, 0x2a, 0x55, 0xaa, 0x55, 0x22, 0x55, 0xaa},
   {0x55, 0x2a, 0x55, 0xaa, 0x55, 0xa2, 0x55, 0xaa},
   {0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa},
   {0x55, 0xab, 0x55, 0xaa, 0x55, 0xba, 0x55, 0xaa},
   {0x55, 0xab, 0x55, 0xaa, 0x55, 0xbb, 0x55, 0xaa},
   {0x55, 0xbb, 0x55, 0xae, 0x55, 0xbb, 0x55, 0xaa},
   {0x55, 0xbb, 0x55, 0xae, 0x55, 0xbb, 0x55, 0xea},
   {0x55, 0xbb, 0x55, 0xee, 0x55, 0xbb, 0x55, 0xee},
   {0x55, 0xbb, 0x55, 0xef, 0x55, 0xbb, 0x55, 0xee},
   {0x55, 0xbb, 0x55, 0xef, 0x55, 0xbb, 0x55, 0xff},
   {0x55, 0xbf, 0x55, 0xff, 0x55, 0xbb, 0x55, 0xff},
   {0x55, 0xbf, 0x55, 0xff, 0x55, 0xfb, 0x55, 0xff},
   {0x55, 0xff, 0x55, 0xff, 0x55, 0xff, 0x55, 0xff},
   {0x57, 0xff, 0x55, 0xff, 0x75, 0xff, 0x55, 0xff},
   {0x57, 0xff, 0x55, 0xff, 0x77, 0xff, 0x55, 0xff},
   {0x77, 0xff, 0x5d, 0xff, 0x77, 0xff, 0x55, 0xff},
   {0x77, 0xff, 0x5d, 0xff, 0x77, 0xff, 0xd5, 0xff},
   {0x77, 0xff, 0xdd, 0xff, 0x77, 0xff, 0xdd, 0xff},
   {0x77, 0xff, 0xdf, 0xff, 0x77, 0xff, 0xfd, 0xff},
   {0x77, 0xff, 0xdf, 0xff, 0x77, 0xff, 0xff, 0xff},
   {0x7f, 0xff, 0xff, 0xff, 0x77, 0xff, 0xff, 0xff},
   {0x7f, 0xff, 0xff, 0xff, 0xf7, 0xff, 0xff, 0xff},
   {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff}
};

/**************************************************************/
/*****************   end of xtangofills.h    ******************/
/**************************************************************/
